'''

Contains the entry point used by the run_game.py script

'''

import sys
import pygame
from pygame.locals import *

import gamelib
from gamelib.miscgfx import *
from gamelib.colpack import *
from gamelib.owt import OWT
from gamelib.owtgfx import *
from gamelib.render import *
from gamelib.landscape import *
from gamelib.player import *
# Globals.
ScreenSize = [640,480]
Debug = True

# Standard Init.
pygame.init()
screen = pygame.display.set_mode(ScreenSize)
pygame.display.set_caption("One Way Trip")
ANIMEVENT = pygame.USEREVENT+3
pygame.time.set_timer(ANIMEVENT, int(1000))
GameBG = CreateBackground(screen)

#------ 
# MAIN
#------
def main():
    GameState = 1
    DrawText(GameBG, 10, 50, "Daftspaniel Presents...", 48, (255,255,255) )
    screen.blit(GameBG, (0, 0))
    pygame.display.flip()
    wo = World(240,240)
    wo.Base()
    wo.Smooth()
    TitleMars = Terrain(wo, GameBG)
    while GameState!=-1:
        
        if GameState == 1: # Title Screen
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit()
                elif event.type == ANIMEVENT:
                    GameBG.fill(pygame.Color("black"))
                    
                    # Background
                    hh = int(ScreenSize[1]/2)
                    gr = Rect(0, 0+hh, ScreenSize[0], hh )
                    pygame.draw.rect(GameBG, Mountains[2], Rect(gr.x, 0, gr.w, hh ), 0)
                    pygame.draw.rect(GameBG, Mountains[0], gr , 0)
                    
                    TitleMars.Render()
                    sm = Spaceman(Rect(100,280,25,100))
                    sm.Draw(GameBG)
                    DrawAlien(GameBG, [((375,300))] )
                    DrawAlien(GameBG, [((325,300))] )
                    DrawAlien(GameBG, [((395,300))] )
                    DrawText(GameBG, 11, 49, "One Way Trip", 48, (0,0,0) )
                    DrawText(GameBG, 11, 51, "One Way Trip", 48, (255,255,255) )
                    
                    
                elif event.type == pygame.KEYDOWN:
                    keystate = pygame.key.get_pressed()
                    if keystate[K_SPACE]:
                        GameState = 2
            
            screen.blit(GameBG, (0, 0))
            pygame.display.flip()
            
        elif GameState == 2: # Game on!
            g = OWT(GameBG, screen, ScreenSize)
            g.MainLoop()
            GameState = 3
                    
        elif GameState == 3: # Game over!
            GameBG.fill(pygame.Color("black"))
            DrawText(GameBG, 8, 50, "Game Over", 78, (255,255,255) )
            DrawText(GameBG, 10, 50, "Game Over", 78, (255,0,0) )
            sm = Spaceman(Rect(400,300,75,300))
            sm.Direction = 4
            sm.Firing = 4
            sm.Draw(GameBG)
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit()
                elif event.type == pygame.KEYDOWN:
                    keystate = pygame.key.get_pressed()
                    if keystate[K_SPACE]:
                        GameState = 1
            screen.blit(GameBG, (0, 0))
            pygame.display.flip()
            
        elif GameState == 4: # Victory
            
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit()
                elif event.type == ANIMEVENT:
                    GameBG.fill(pygame.Color("black"))
                    DrawText(GameBG, 10, 50, "Well Done!", 48, (255,0,0) )
                    w = int(ScreenSize[1]*0.75)
                    cr = Rect( int(ScreenSize[0]*0.125), int(ScreenSize[1]*0.125), w, w)
                    pygame.draw.rect(GameBG, Color(0,0,0), cr , 1)
                    cv = CompView(cr, 2)
                    cv.Draw(GameBG)
                elif event.type == pygame.KEYDOWN:
                    keystate = pygame.key.get_pressed()
                    if keystate[K_SPACE]:
                        GameState = 1
            screen.blit(GameBG, (0, 0))
            pygame.display.flip()
