import pygame
from pygame.locals import *

def CreateBackground(screen):
    bg = pygame.Surface(screen.get_size())
    bg = bg.convert()
    return bg

def DrawText(bg, x, y, text, size=24, color=(255, 255, 255)):
    inst1_font = pygame.font.Font(None, size)
    inst1_surf = inst1_font.render(text, 1, color)
    bg.blit(inst1_surf, [x, y])

def DrawHealthBar( surf, ph, x, y):
    pygame.draw.rect(surf, Color(255,255,255), Rect(x,y,100,10) , 0)
    if ph<25:
        hc = Color(255,0,0)
    else:
        hc = Color(255,164,46)
    
    pygame.draw.rect(surf, hc,  Rect(x,y, ph ,10) , 0)
    pygame.draw.rect(surf, Color(0,0,0), Rect(x,y,100,10) , 1)

def DrawMountain(surf, skyrect, col, peaks):
    r = skyrect.inflate(0, 10)
    pl = []
    spa = r.w/((peaks+1)*2)
    peak = int(r.h/(10-peaks))
    pl.append(  (r.x, r.y + r.h) )
    pl.append(  (r.x+spa, r.y + peak) )
    pl.append(  (r.x+r.w, r.y + r.h) )
    pygame.draw.polygon(surf, col, pl, 0)
