import pygame
import sys
import random

from pygame.event import *
from pygame.locals import *

from gamelib.colpack import *
from gamelib.miscgfx import *
from gamelib.render import *
from gamelib.landscape import *
from gamelib.player import *

TIMEREVENT = pygame.USEREVENT
pygame.time.set_timer(TIMEREVENT, 100)
pygame.mixer.init()

class OWT(object):
    """
        Main game class.
    """
    def __init__(self, GameBG, Screen, ScreenSize):
        self.GameBG = GameBG
        self.Screen = Screen
        self.ScreenSize = ScreenSize
        self.SetUpWorld()
        self.JC = Player()
        self.JC.Health = 65
        self.Map = False
        self.MapDrawn = False
        self.RaySFX = pygame.mixer.Sound("mars.wav")
        self.Pause = 12
        
    def SetUpWorld(self):
        wo = World(240,240)
        wo.Base()
        wo.Generate()
        #wo.Smooth()
        wo.Smooth()
        wo.Populate()
        
        self.Mars = wo
        self.MarsView3D = Terrain(wo, self.GameBG)
        self.Sky = Sky(self.GameBG)
        
    def DrawMap(self, screen):
        screen.fill(pygame.Color("black"))
        s = 240
        wo = self.Mars
        w=2
        y=20
        for j in range(s):
            x = 80
            y += w
            for k in range(s):
                x += w
                c = wo.map_data[j][k]*10
                if c>255: c=255
                pygame.draw.rect(screen,Color(c,0,0), Rect(x, y, w, w ), 0)
                if self.MarsView3D.PlayerX==j and self.MarsView3D.PlayerY==k:
                    pygame.draw.rect(screen,Color(255,255,255), Rect(x, y, w, w ), 0)
    def MainLoop(self):
        
        while self.JC.Health>0:
            for event in pygame.event.get():
                
                if event.type == pygame.QUIT:
                    sys.exit()
                    
                elif event.type == pygame.KEYUP:
                    keystate = pygame.key.get_pressed()
                    if keystate[K_m]:
                        self.Map = False
                elif event.type == pygame.KEYDOWN:
                    keystate = pygame.key.get_pressed()
                    if keystate[K_F12]==1:
                        return
                    if keystate[K_d]:
                        if self.JC.Firing<1:
                            self.MarsView3D.LO+=1
                            self.MarsView3D.Sman.Direction = 2
                    elif keystate[K_a]:
                        if self.JC.Firing<1:
                            self.MarsView3D.LO-=1
                            self.MarsView3D.Sman.Direction = 4
                    elif keystate[K_s]:
                        if self.JC.Firing<1:
                            self.MarsView3D.TO+=1
                            self.MarsView3D.LO+=1
                            self.MarsView3D.Sman.Direction = 3
                            #if not self.JC.RayPos is None:
                            #    self.JC.RayPos = (self.JC.RayPos[0] - 20, self.JC.RsayPos[1] - 20)
                    elif keystate[K_w]:
                        self.MarsView3D.Sman.Direction = 1
                        if self.JC.Firing<1:
                            self.MarsView3D.TO-=1
                            self.MarsView3D.LO-=1
                    elif keystate[K_l]:
                        self.MarsView3D.Sman.Direction = 2
                        if self.JC.Firing<1:
                            self.JC.Firing = 2
                            self.JC.Ray = 3
                            self.JC.RayMoveX = 10
                    elif keystate[K_j]:
                        self.MarsView3D.Sman.Direction = 4
                        if self.JC.Firing<1:
                            self.JC.Firing = 4
                            self.JC.Ray = 3
                            self.JC.RayMoveX = -10
                    elif keystate[K_k]:
                        self.MarsView3D.Sman.Direction = 3
                        if self.JC.Firing<1:
                            self.JC.Firing = 4
                            self.JC.Ray = 3
                            self.JC.RayMoveX = -10
                    elif keystate[K_i]:
                        if self.JC.Firing<1:
                            self.MarsView3D.Sman.Direction = 1
                            self.JC.Firing = 4
                            self.JC.Ray = 3
                            self.JC.RayMoveX = -10
                            
                    elif keystate[K_u]:
                        if self.MarsView3D.PlayerPosition in self.Mars.Items:
                            for item in self.Mars.Items[self.MarsView3D.PlayerPosition]:
                                self.JC.Health = self.JC.Health + 10
                                del self.Mars.Items[self.MarsView3D.PlayerPosition]
                    elif keystate[K_m]:
                        if not self.Map:
                            self.Map = True
                            self.MapDrawn = False
                            print("Showmap")
                        else:
                            self.Map = False
                            self.MapDrawn = False
                            print("Hide map")
                    
                elif event.type == TIMEREVENT:
                    self.GameBG.fill(pygame.Color("black"))
                    #--
                    if self.Map:
                        if not self.MapDrawn:
                            self.DrawMap(self.GameBG)
                            self.Screen.blit(self.GameBG, (0, 0))
                            pygame.display.flip()
                            self.MapDrawn = True

                    else:
                        if not self.MarsView3D.Sman is None:
                            self.MarsView3D.Sman.Firing = self.JC.Firing
                        self.Sky.Render()
                        self.MarsView3D.Render()
                        
                        
                        DrawText(self.GameBG, 46, 8, "SCORE " + str(self.JC.Score), 16, (0,0,0) )
                        DrawText(self.GameBG, 48, 8, "SCORE " + str(self.JC.Score), 16, (255,255,255) )
                        
                        
                        DrawText(self.GameBG, 465, 8, "HEALTH", 14, (0,0,0) )
                        DrawText(self.GameBG, 467, 8, "HEALTH", 14, (255,255,255) )
                        DrawHealthBar(self.GameBG, self.JC.Health, 520, 5)
                        #DrawText(self.GameBG, 46,8, self.MarsView3D.PlayerPosition, 24, (255,255,255) )
                        ppp = self.MarsView3D.PlayerPos
                        
                        
                        if self.JC.Firing>0:
                            if self.JC.RayPos is None:
                                self.JC.RayPos =  (ppp[0][0]+self.JC.RayMoveX, ppp[0][1]-20)
                            #DrawRay(self.GameBG, self.JC.Ray, self.JC.RayPos[0], self.JC.RayPos[1])
                            if self.MarsView3D.Sman.Direction == 2:
                                DrawRay(self.GameBG, 150, self.JC.RayPos[0], self.JC.RayPos[1])
                            elif self.MarsView3D.Sman.Direction == 3:
                                DrawVRay(self.GameBG, 90, self.JC.RayPos[0]+10, self.JC.RayPos[1])
                            elif self.MarsView3D.Sman.Direction == 4:
                                DrawRay(self.GameBG, 150, self.JC.RayPos[0]-150, self.JC.RayPos[1])
                            elif self.MarsView3D.Sman.Direction == 1:
                                DrawVRay(self.GameBG, 90, (self.JC.RayPos[0])-82, self.JC.RayPos[1]-85)
                            
                            self.JC.Score += 20 * self.Mars.ZapAliens( (self.MarsView3D.PlayerX,self.MarsView3D.PlayerY), self.MarsView3D.Sman.Direction)
                            self.RaySFX.play()
                            #self.JC.Ray -= 4
                            #self.JC.RayPos = (self.JC.RayPos[0]+self.JC.RayMoveX, self.JC.RayPos[1])
                            #if self.JC.RayPos[0]>640 or self.JC.RayPos[0]<0:
                            self.JC.Ray -= 1
                            if self.JC.Ray<0:
                                self.JC.Firing = 0
                                self.JC.RayPos = None
                                self.RaySFX.stop()
                        if self.MarsView3D.PlayerPosition in self.Mars.Items:
                            for item in self.Mars.Items[self.MarsView3D.PlayerPosition]:
                                if item==2:
                                    self.JC.Health = self.JC.Health -5
                        ## Give a little delay for aliens at start of game
                        if self.Pause==0:
                            self.Mars.MoveAliens3( (self.MarsView3D.TO,self.MarsView3D.LO), (self.MarsView3D.PlayerX,self.MarsView3D.PlayerY) )
                        else:
                            self.Pause -= 1
                    #3
                        self.Screen.blit(self.GameBG, (0, 0))
                        pygame.display.flip()
