import pygame
from pygame.locals import *
from random import Random, random
from gamelib.colpack import *

def DrawPlayer(screen, pos):
    pygame.draw.rect(screen,Color(0,232,0), Rect(pos[0][0]+16, pos[0][1]-12, 6, 24 ), 0)
    #pygame.draw.polygon(screen, Color(0,232,0),pos, 1)
    
def DrawFirstAid(screen, pos):
    pygame.draw.rect(screen,Color(255,255,255), Rect(pos[0][0]+25, pos[0][1]+5, 10, 10 ), 0)
    #pygame.draw.polygon(screen, Color(0,232,0),pos, 1)
    
def DrawRay(screen, strength, x, y):
    pygame.draw.rect(screen, Color(255,Random().randint(33,200), 0), Rect(x+14,y+14,strength,2) , 0)
    
def DrawVRay(screen, strength, x, y):
    #pygame.draw.rect(screen, Color(255,Random().randint(33,200), 0), Rect(x+14,y+14,2,strength) , 0)
    p = []
    p.append((x+14, y+14))
    p.append((x+14 + strength, y+14+strength ))
    p.append((x+16 + strength, y+14+strength ))
    p.append((x+16, y+14))
    pygame.draw.polygon(screen, Color(255,Random().randint(33,200),0),p, 0)
    
def DrawAlien2(screen,pos):
    c = Colour([0,255,0])
    r = Rect(pos[0][0]+16, (pos[0][1]-12),12,36)
    for i in range(24):
        c.Darken(Random().randint(6,10))
        pygame.draw.rect(screen,c.Color, Rect(pos[0][0]+16, (pos[0][1]-12)+i, 12, 10 ), 0)
    
    pygame.draw.circle(screen, Color("yellow"), (pos[0][0]+23, pos[0][1]-4) ,5)
    v=Random().randint(1,5)-2
    pygame.draw.circle(screen, Color("red"), (pos[0][0]+22+v, pos[0][1]-6+v) ,2)
    pygame.draw.circle(screen, Color("black"), (pos[0][0]+23, pos[0][1]-4) ,5,1)
    pygame.draw.circle(screen, Color("black"), (pos[0][0]+22+v, pos[0][1]-6+v) ,2,1)
    #pygame.draw.rect(screen,Color("pink"), r, 0)
def DrawAlien3(screen,pos):
    r = Rect(pos[0][0]+16, pos[0][1]+12,12,12)
    pygame.draw.rect(screen,Color("pink"), r, 0)
def DrawDeadAlien2(screen,pos):
    c = Colour([0,75,0])
    r = Rect(pos[0][0]+20, (pos[0][1]-12),24,36)
    pygame.draw.rect(screen,c.Color, Rect(pos[0][0]+16, (pos[0][1]-12)+24, 24, 10 ), 0)
    
    pygame.draw.circle(screen, Color(236,244,57), (pos[0][0]+23, pos[0][1]+20) ,5)
    v=0
    pygame.draw.circle(screen, Color("red"), (pos[0][0]+22, pos[0][1]+20+v) ,2)
    pygame.draw.circle(screen, Color("black"), (pos[0][0]+23, pos[0][1]+20) ,5,1)
    pygame.draw.circle(screen, Color("black"), (pos[0][0]+22, pos[0][1]+20+v) ,2,1)
    #pygame.draw.rect(screen,Color("pink"), r, 0)
    
def DrawAlien(screen,pos):
    c = Colour([0,255,0])
    for i in range(24):
        c.Darken(Random().randint(6,16))
        pygame.draw.rect(screen,c.Color, Rect(pos[0][0]+16, (pos[0][1]-12)+i, 12, 10 ), 0)
    pygame.draw.circle(screen, Color("yellow"), (pos[0][0]+23, pos[0][1]-4) ,5)
    v=Random().randint(1,3)
    pygame.draw.circle(screen, Color("red"), (pos[0][0]+22+v, pos[0][1]-6+v) ,2)
    pygame.draw.circle(screen, Color("black"), (pos[0][0]+23, pos[0][1]-4) ,5,1)
    pygame.draw.circle(screen, Color("black"), (pos[0][0]+22+v, pos[0][1]-6+v) ,2,1)
    
class Spaceman(object):
    def __init__(self, limits):
        self.Firing = 0
        self.SetSize(limits)
        self.Direction = 2
    def SetSize(self,limits):
        self.rect = limits
        self.VisorColor = pygame.Color(0,219,0)
        self.SuitColor = pygame.Color(239,239,239)
        self.EdgeColor= pygame.Color(29,29,29)
        r = self.rect
        self.helmet = Rect(r.left, r.top, r.width, int(r.height/3))
        self.visor = Rect( (r.midtop[0], r.midtop[1]+int(r.height/10)), (int(r.w/1.9), int(r.height/9)) )
        self.visord = Rect( (r.left, r.midtop[1]+int(r.height/10)), (r.w, int(r.height/9)) )
        
        self.visorl = Rect( (r.left, r.midtop[1]+int(r.height/10)), (int(r.w/1.9), int(r.height/9)) )
        self.torso = Rect(self.helmet.bottomleft, (int(self.helmet.width*0.90),int(r.height/3)) )
        self.lleg = Rect(self.torso.bottomleft, (int(r.w/2),int(r.height/3)) )
        self.rleg = Rect(self.torso.midbottom, (int(r.w/2),int(r.height/3)) )
        self.larm = Rect(self.torso.topleft, (int(r.w/2),int(r.height/3.5)) )
        self.larm.left -= int(r.w/4)
        self.larm2 = Rect(self.torso.topright, (int(r.w/2),int(r.height/3.5)) )
        self.larm2.left -= int(r.w/4)
        
        al = int(r.height/3.5)
        
        #left
        t = (self.torso.topleft[0]-al, self.torso.topright[1])
        self.farml = Rect( t, (al, int(r.w/2)) )
        t = (self.torso.topleft[0]-(al*2), self.torso.topright[1])
        self.fgunl = Rect( t, (al, int(r.w/4)) )
        #right
        self.farm = Rect(self.torso.topleft, (int(r.height/3.5),int(r.w/2)) )
        self.fgun = Rect(self.torso.topright, (int(r.height/3.5),int(r.w/4)) )
        
    def Draw(self, s):
        if self.Direction == 2:
            self.DrawRightArmLowered(s)
            self.DrawHelmetR(s)
            self.DrawTorso(s)
            self.DrawLeftArm(s)
            self.DrawLLeg(s)
            self.DrawRLeg(s)
        elif self.Direction == 4:
            self.DrawLeftArm(s)            
            self.DrawHelmetL(s)
            self.DrawTorso(s)
            self.DrawRightArmLowered(s)
            self.DrawRLeg(s)
            self.DrawLLeg(s)            
        elif self.Direction == 1:
            self.DrawRightArmLowered(s)
            self.DrawHelmetU(s)
            self.DrawTorso(s)
            self.DrawLeftArm(s)
            self.DrawLLeg(s)
            self.DrawRLeg(s)
        elif self.Direction == 3:
            self.DrawRightArmLowered(s)
            self.DrawHelmetD(s)
            self.DrawTorso(s)
            self.DrawLeftArm(s)
            self.DrawLLeg(s)
            self.DrawRLeg(s)
    def DrawRightArmLowered(self, s):
        pygame.draw.rect(s, self.SuitColor , self.larm2, 0)
        pygame.draw.rect(s, self.EdgeColor , self.larm2, 1)
        
    def DrawLeftArm(self,s):
        if self.Firing>0:
            if (self.Direction ==2):
                pygame.draw.rect(s, self.SuitColor , self.farm, 0)
                pygame.draw.rect(s, self.EdgeColor , self.farm, 1)
                pygame.draw.rect(s, self.EdgeColor , self.fgun, 0)
            if (self.Direction ==1):
                pygame.draw.rect(s, self.SuitColor , self.farml, 0)
                pygame.draw.rect(s, self.EdgeColor , self.farml, 1)
                #pygame.draw.rect(s, self.EdgeColor , self.fgunl, 0)
            elif (self.Direction ==4):
                pygame.draw.rect(s, self.SuitColor , self.farml, 0)
                pygame.draw.rect(s, self.EdgeColor , self.farml, 1)
                pygame.draw.rect(s, self.EdgeColor , self.fgunl, 0)                
        else:
            pygame.draw.rect(s, self.SuitColor , self.larm, 0)
            pygame.draw.rect(s, self.EdgeColor , self.larm, 1)
        
    def DrawHelmetR(self, s):
        pygame.draw.rect(s, self.SuitColor , self.helmet, 0)
        pygame.draw.rect(s, self.EdgeColor , self.helmet, 1)
        pygame.draw.rect(s, self.VisorColor, self.visor, 0)
        #pygame.draw.rect(s, self.EdgeColor , self.visor, 1)        
        
    def DrawHelmetL(self, s):
        pygame.draw.rect(s, self.SuitColor , self.helmet, 0)
        pygame.draw.rect(s, self.EdgeColor , self.helmet, 1)
        pygame.draw.rect(s, self.VisorColor, self.visorl, 0)
        #pygame.draw.rect(s, self.EdgeColor , self.visorl, 1) 
        
    def DrawHelmetD(self, s):
        pygame.draw.rect(s, self.SuitColor , self.helmet, 0)
        pygame.draw.rect(s, self.EdgeColor , self.helmet, 1)
        pygame.draw.rect(s, self.VisorColor, self.visord, 0)
        #pygame.draw.rect(s, self.EdgeColor , self.visord, 1) 
          
    def DrawHelmetU(self, s):
        pygame.draw.rect(s, self.SuitColor , self.helmet, 0)
        pygame.draw.rect(s, self.EdgeColor , self.helmet, 1)
          
    def DrawTorso(self, s):
        pygame.draw.rect(s, self.SuitColor , self.torso, 0)
        pygame.draw.rect(s, self.EdgeColor , self.torso, 1)   
    def DrawLLeg(self, s):
        pygame.draw.rect(s, self.SuitColor , self.lleg, 0)
        pygame.draw.rect(s, self.EdgeColor , self.lleg, 1)
    def DrawRLeg(self, s):        
        pygame.draw.rect(s, self.SuitColor , self.rleg, 0)
        pygame.draw.rect(s, self.EdgeColor , self.rleg, 1)
        
        
