import pygame
import sys
from pygame.locals import *
from miscgfx import *
#Color Definitions for game - feel free to modify!
Sky = [ Color(0,0,55), Color(50,0,145), Color(0,0,255) ]
Foliage = [ Color(0,55,0), Color(0,155,0), Color(0,205,0), Color(0,245,0)]
Trunk = [ Color(70,35,10), Color(100,91,14), Color(145,101,23)]
Ground = [ Color(11,65,60), Color(17,155,80), Color(139,207,136)]
Grit = [ Color(8,10,11), Color(17,20,22), Color(25,39,34)]
BadGuys = [ Color(55,0,0), Color(155,0,0), Color(255,0,0)]
BadEyes = [ Color(196,215,29), Color(216,235,49), Color(236,255,69)]
Laser = [ Color(255,247,23), Color(255,247,23), Color(255,247,23)]
Component = [ Color(55,55,55), Color(95,95,95), Color(145,145,145)]
Mountains = [ Color(124,33,22), Color(164,54,27), Color(194,44,33)]

cchart = [Sky, Ground, Grit, Trunk, Foliage, BadGuys, BadEyes, Component, Laser, Mountains]

class Colour(object):
    def __init__(self, RGB):
        self.RGB = RGB
        self.Correct()
    def Darken(self, delta):
        self.RGB[0] -=delta
        self.RGB[1] -=delta
        self.RGB[2] -=delta
        self.Correct()
    def Lighten(self, delta):
        self.RGB[0] +=delta
        self.RGB[1] +=delta
        self.RGB[2] +=delta
        self.Correct()
    def Correct(self):
        for i in range(3):
            if self.RGB[i]>255: self.RGB[i] = 255
            if self.RGB[i]<0: self.RGB[i] = 0
        self.Color = Color(self.RGB[0],self.RGB[1],self.RGB[2])

#----------------------------------------
#Add test tool to view game items
if __name__=="__main__":
    WINSIZE = 640,680
    pygame.init()
    screen = pygame.display.set_mode(WINSIZE,0,8)
    pygame.display.set_caption("Colour Palette for One Way Trip")
    pygame.init()
    y = 0
    w = 20
    DrawMountain(screen, Rect(0,0,100,100),Mountains[0], 4),
    DrawMountain(screen, Rect(100,0,100,100),Mountains[1], 2),
    DrawMountain(screen, Rect(200,0,100,100),Mountains[2], 14),
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
        pygame.display.update()
