from gamelib.colpack import *
from gamelib.owtgfx import *
from gamelib.miscgfx import *
class Sky(object):
    def __init__(self, surface):
        self.Surface = surface
    def Render(self):
        s=340
        for k in range(s):
            c = 255-k
            if c>255: c=255
            if c<0: c=0
            pygame.draw.rect(self.Surface, Color(0,0,c), Rect(0, k, 640, 2), 0)

class Terrain(object):
    def __init__(self, world, surface):
        self.World = world
        self.Surface = surface
        self.LO = 0
        self.TO = 0
        self.PlayerX = -1
        self.PlayerY = -1
        self.Sman = None
        self.Targets = []

    @property
    def PlayerPosition(self):
        return str(self.PlayerX) + "," +str(self.PlayerY)
    def Render(self):
        Px=0
        Py=0
        LO = self.LO
        TO = self.TO
        
        screen = self.Surface
        wo = self.World
        self.Targets = []
        x=20
        y=20
        V = 12
        w = 30
        OY = 200
        OX = -300
        i = 0
        
        for j in range(V):
            toptiles =[]
            sidetiles =[]
            fronttiles =[]
            cols =[]
            x = 0
            y += w
            Pxi = -1
            faid = -1
            aliens = []
            deadaliens = []
            aliensloc = {}
            for k in range(V*3):
                x += w
                if TO+j>240 or LO+k>240:
                    break
                c = wo.map_data[TO+j][LO+k]*10
                if c>255: c=255
                h=int(c/3)
                pl =[]
                tx = OX + i + x
                ty = -h + OY + y
                sidetiles.append([ (tx, ty), (tx, ty + h), (tx + w, ty + w +h), (tx + w, ty + w)])
                toptiles.append([ (tx, ty), (tx + w, ty), (tx + w*2, ty + w), (tx+w, ty + w) ])
                fronttiles.append([ (tx + w, ty + w +h),(tx +w, ty+w),  (tx + w +w, ty + w), (tx + w +w,ty + w +h)])
                cols.append(Colour([c,0,0]))
                
                if j==4 and k==12:
                    Px= OX+ i + x
                    Py= -h + OY + y
                    Pxi = len(toptiles) - 1
                    self.PlayerX = TO + j
                    self.PlayerY = LO + k
                if j==4 and k==20:
                    triPx= OX+ i + x
                    triPy= -h + OY + y
                #Item.
                ii = str(TO+j) + "," + str(LO+k)
                
                #Check if this title has items.
                if ii in wo.Items:
                    for fi in wo.Items[ii]:
                        if fi==1: # First Aid.
                            faid = len(cols) - 1
                        elif fi==2:
                            aliens.append(len(cols) - 1)
                            aliensloc[LO+k] = ii
                        elif fi==3:
                            deadaliens.append(len(cols) - 1)
            i+=w
            
            #Draw it
            i = 0
            Pxi = len(toptiles) - Pxi
            faid = len(toptiles) - faid
            sidetiles.reverse()
            toptiles.reverse()
            fronttiles.reverse()
            cols.reverse()
            aliens = [len(toptiles)-a  for a in aliens]
            deadaliens = [len(toptiles)-a  for a in deadaliens]
                
            #aliens.reverse()
            #deadaliens.reverse()
            for tile in sidetiles:
                
                cols[i].Darken(20)
                pygame.draw.polygon(screen, cols[i].Color, tile, 0)
                
                cols[i].Reset()
                pygame.draw.polygon(screen, cols[i].Color, toptiles[i], 0)
                
                cols[i].Reset()
                cols[i].Darken(10)
                pygame.draw.polygon(screen, cols[i].Color, fronttiles[i], 0)
                
                cols[i].Reset()
                cols[i].Lighten(40)
                pygame.draw.polygon(screen, cols[i].Color, toptiles[i], 1)
                
                #DrawText(screen, toptiles[i][0][0], toptiles[i][0][1]-30, aliensloc[len(cols)-i], 24, (255,255,255) )
                
                if i in aliens:
                    #print("Alien Draw")                    
                    #print(i)
                    #print(len(cols))
                    #print(len(cols) - i)
                    #print(aliensloc)
                    DrawAlien2(screen, toptiles[i])
                    #self.Targets.append(toptiles[i])
                    #aliensloc[i]len(cols) - 1
                    #DrawText(screen, toptiles[i][0][0], toptiles[i][0][1]-30, aliensloc[len(cols)-i], 24, (255,255,255) )
                if i in deadaliens:
                    DrawDeadAlien2(screen, toptiles[i])
                if Pxi==i and Pxi>0:
                    #DrawPlayer(screen, toptiles[i])
                    sp = Rect(toptiles[i][0][0]+16, toptiles[i][0][1]-12, 8,24) 
                    if self.Sman is None:
                        self.Sman = Spaceman(sp)
                    else:
                        self.Sman.SetSize(sp)
                    self.Sman.Draw(screen)
                    self.PlayerPos = toptiles[i]
                if faid==i and faid>0:
                    DrawFirstAid(screen, toptiles[i])
                
                #Items
                #if self.Items
                i+=1

