import pygame
import sys
import math
import random
from pygame.locals import *

def DrawTripod(screen,X,Y,unit):
    legwidth = int(unit/5)
    hlegwidth = int(legwidth/2)
    head = [ (X+unit*2,Y+unit*2), (X+unit*4,Y+unit), (X+unit*6,Y+unit*2), (X+unit*4,Y+unit*3) ]
    lp = head[0]
    leg1 = [ lp, (lp[0]+legwidth,lp[1]), (lp[0]+legwidth,lp[1]+unit*3), (lp[0],lp[1]+unit*3)]
    
    lp = (head[3][0]-hlegwidth,head[3][1]-hlegwidth)
    leg2 = [ lp, (lp[0]+legwidth,lp[1]), (lp[0]+legwidth,lp[1]+unit*3), (lp[0],lp[1]+unit*3)]
    
    lp = (head[2][0]-legwidth,head[2][1])
    leg3 = [ lp, (lp[0]+legwidth,lp[1]), (lp[0]+legwidth,lp[1]+unit*3), (lp[0],lp[1]+unit*3)]
    
    lc = Color(144,88,88)
    pygame.draw.polygon(screen, lc, leg1, 0)
    pygame.draw.polygon(screen, lc, leg2, 0)
    pygame.draw.polygon(screen, lc, leg3, 0)
    pygame.draw.polygon(screen, Color("grey"), head, 0)

if __name__=="__main__":
    WINSIZE = 640,680
    pygame.init()
    screen = pygame.display.set_mode(WINSIZE,0,8)
    pygame.display.set_caption("Tripod")
    
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
            if event.type == pygame.KEYDOWN:
                screen.fill(pygame.Color("black"))
                DrawTripod(screen,40,40, random.randint(10,20))
        pygame.display.update()

